#
#  It then allows you to load data into the other buttons, and to 
#  commit or not-commit the data, one row at a time.
#
#  I'm hoping that the Job and Camera information can be entered through
#  MiBrowse.
#
set MB(Home) $env(MIBROWSE)
set MB(Bin) $MB(Home)/bin
lappend auto_path $MB(Home)/lib
#
# source /usr/local/devel/montage/contrib/MiBrowse/lib/tku.tcl
# set GC(conn) [ mi_open Eureka ]
set GC(conn) [ mi_open Reserve ]
set location /tmp_mnt/import/epoch/ftp/pub/elib/data/delta/aerial/tiff
set Filename ""
set ShowTxt "Show Photo"
set NextTxt "Next Photo"
set PrevTxt "Prev Photo"
set ClearTxt "Clear Changes"
set CommitTxt "Commit Updates"
set ClosTxt "Quit"
list tablist

set Fields [ list file_name browse_photo photo_date f_line photo_no job series center_x center_y nw_corner se_corner ]
foreach i $Fields {
  set VAR($i) ""
}
set VAR(oid) 0
#
# 
proc XV {} {
 global VAR GC
 set GetQry "
SELECT LOToFile(P.browse_photo,'/tmp/_TMP_')
  FROM Photo_Data P
 WHERE P.file_name = '$VAR(file_name)';"

 puts "Query is :
$GetQry
"
 set FileName [ mi_select_first_row $GC(conn) $GetQry ]
 puts $FileName
 set Cmd "/home2/pbrown/bin/xvrm $FileName"
 puts $Cmd

# if { [ file type $VAR(browse_photo) ] == "file" } {

    exec /home2/pbrown/bin/xvrm $FileName &

# } else {
#    Tku_Error "Display Error: File $VAR(browse_photo) can't be displayed"
# }
 
 puts "Remove it "

}
proc Next {} {
  global VAR GC Fields
  if { $VAR(oid) != 0 } {
#
#  Finding the next one up.
#
  set NextQry "
SELECT oid,
       file_name,
       browse_photo,
       photo_date,
       f_line,
       photo_no, 
       job,
       series,
       center_x,
       center_y,
       nw_corner,
       se_corner
  FROM Photo_Data PD1
 WHERE PD1.file_name = (SELECT MIN(PD2.file_name)
                          FROM Photo_Data PD2
                         WHERE PD2.file_name > '$VAR(file_name)');"
 } else {
#
# First 
#
set NextQry "
SELECT oid,
       file_name,
       browse_photo,
       photo_date,
       f_line,
       photo_no, 
       job,
       series,
       center_x,
       center_y,
       nw_corner,
       se_corner
  FROM Photo_Data PD1
 WHERE PD1.file_name = (SELECT MIN(PD2.file_name)
                          FROM Photo_Data PD2);"
}
  set Result [ mi_select_rows $GC(conn) $NextQry ]
  set Res [ lindex $Result 0 ]
  set VAR(oid) [ lindex $Res 0 ]
  set i 1
  foreach j $Fields {
    set VAR($j) [ lindex $Res $i ]
    incr i
  }
}
proc Prev {} {
  global VAR GC Fields
  if { $VAR(oid) != 0 } {
#
#  Finding the next one up.
#
  set NextQry "
SELECT oid,
       file_name,
       browse_photo,
       photo_date,
       f_line,
       photo_no,
       job,
       series,
       center_x,
       center_y,
       nw_corner,
       se_corner
  FROM Photo_Data PD1
 WHERE PD1.file_name = (SELECT MAX(PD2.file_name)
                          FROM Photo_Data PD2
                         WHERE PD2.file_name < '$VAR(file_name)');"
 } else {
#
# First
#
set NextQry "
SELECT oid,
       file_name,
       browse_photo,
       photo_date,
       f_line,
       photo_no,
       job,
       series,
       center_x,
       center_y,
       nw_corner,
       se_corner
  FROM Photo_Data PD1
 WHERE PD1.file_name = (SELECT MAX(PD2.file_name)
                          FROM Photo_Data PD2);"
}
  set Result [ mi_select_rows $GC(conn) $NextQry ]
  set Res [ lindex $Result 0 ]
  set VAR(oid) [ lindex $Res 0 ]
  set i 1
  foreach j $Fields {
    set VAR($j) [ lindex $Res $i ]
    incr i
  }
}
proc Clear {} {
  global VAR GC Fields
  set ClrQry "
SELECT oid,
       file_name,
       browse_photo,
       photo_date,
       f_line,
       photo_no,
       job,
       series,
       center_x,
       center_y,
       nw_corner,
       se_corner
  FROM Photo_Data PD1
 WHERE PD1.oid = '$VAR(oid)'::oid;"

  set Result [ mi_select_rows $GC(conn) $ClrQry ]
  set Res [ lindex $Result 0 ]
  set VAR(oid) [ lindex $Res 0 ]
  set i 1
  foreach j $Fields {
    set VAR($j) [ lindex $Res $i ]
    incr i
  }
}
proc Commit {} {
  global VAR GC Fields
  set UpdQry "
UPDATE Photo_Data
   SET "
#
#  Painful!!
#
   if { $VAR(photo_date) == "(null)" } {
     set UpdQry "$UpdQry 
    photo_date = NULL::date,"
   } else {
     set UpdQry "$UpdQry 
    photo_date = '$VAR(photo_date)'::date,"
   }

   if { $VAR(f_line) == "(null)" } {
     set UpdQry "$UpdQry 
    f_line = NULL::integer,"
   } else {
     set UpdQry "$UpdQry 
    f_line = '$VAR(f_line)'::integer,"
   }

   if { $VAR(photo_no) == "(null)" } {
     set UpdQry "$UpdQry 
    photo_no = NULL::integer,"
   } else {
     set UpdQry "$UpdQry 
    photo_no = '$VAR(photo_no)'::integer,"
   }

   if { $VAR(job) == "(null)" } {
     set UpdQry "$UpdQry
     job = NULL::text,"
   } else {
     set UpdQry "$UpdQry 
     job = '$VAR(job)'::text,"
   }

   if { $VAR(center_x) == "(null)" } {
     set UpdQry "$UpdQry
     center_x = NULL::double precision,"
   } else {
     set UpdQry "$UpdQry 
     center_x = '$VAR(center_x)'::double precision,"
   }

   if { $VAR(center_y) == "(null)" } {
     set UpdQry "$UpdQry
     center_y = NULL::double precision,"
   } else {
     set UpdQry "$UpdQry 
     center_y = '$VAR(center_y)'::double precision,"
   }

   if { $VAR(nw_corner) == "(null)" } {
     set UpdQry "$UpdQry
     nw_corner = NULL::double precision,"
   } else {
     set UpdQry "$UpdQry 
     nw_corner = '$VAR(nw_corner)'::double precision,"
   }

   if { $VAR(se_corner) == "(null)" } {
     set UpdQry "$UpdQry
     se_corner = NULL::double precision"
   } else {
     set UpdQry "$UpdQry 
     se_corner = '$VAR(se_corner)'::double precision"
   }

  set UpdQry "$UpdQry
  WHERE oid = '$VAR(oid)'::oid;"

  mi_exec $GC(conn) $UpdQry

}

proc Quit {} {
  destroy 
  exit
}
proc tab list {
  set i [ lsearch -exact $list [focus]]
  incr i
  if { $i >= [ llength $list] } {
    set i 0
  }
  focus [ lindex $list $i ]
}
#
#
wm title . "Eureka Photo Id and Meta Data"
wm geom . +150+150
wm minsize . 50 50
#
#
Tku_MenuBar .menu
Tku_MenuButton .menu "File -under 0" \
	"checkbutton -label {Quit} -command Quit"
Tku_StatusBar	.info "Data entry for the Aerial Photos"
frame		.buttons
Tku_Button	.buttons.prev $PrevTxt Prev
Tku_Button	.buttons.next $NextTxt Next
Tku_Button	.buttons.clear $ClearTxt Clear
Tku_Button	.buttons.xv   $ShowTxt XV
Tku_Button	.buttons.commit $CommitTxt Commit
Tku_Button	.buttons.quit $ClosTxt Quit
pack .buttons.prev .buttons.next .buttons.clear .buttons.xv .buttons.commit .buttons.quit \
     -side left -padx 2m -pady 2m -ipadx 2m -ipady 2m

frame .fields
foreach i $Fields {
 puts $i
 frame .fields.$i
 label .fields.$i.label -text $i -width 12
 if { $i == "file_name" || $i == "browse_photo" } {
   entry .fields.$i.nty -width 50 -relief sunken -bd 2 -textvariable VAR($i) -state disabled
 } else {
   entry .fields.$i.nty -width 50 -relief sunken -bd 2 -textvariable VAR($i)
   lappend tablist .fields.$i.nty
   bind .fields.$i.nty <Tab> { tab $tablist }
   bind .fields.$i.nty <Return> { tab $tablist }
 }
 pack .fields.$i.label -side left -padx 1m -anchor e
 pack .fields.$i.nty -side right -padx 1m -pady 2m  -anchor w
 pack .fields.$i -side top -anchor e
}
pack .menu .info -fill x
pack .fields
pack .buttons
