#
#  It then allows you to load data into the other fields, and to 
#  commit or not-commit the data, one row at a time.
#
#  I'm hoping that the Job and Camera information can be entered through
#  MiBrowse.
#
set mconn [ mi_open Eureka ]
set location /tmp_mnt/import/epoch/ftp/pub/elib/data/delta/aerial/tiff
set Filename ""
#
# 
proc XV {} {
 global location Filename
 set FileName "$location/$Filename"
 set Cmd "/usr/local/X11/bin/xv $FileName"
 puts $FileName
}
proc Prev {} {
 puts Previous
}
proc Next {} {
 puts Next
}
#
toplevel .sp
wm title .sp "Eureka Photo Id and Meta Data"
wm geom .sp +150+150
wm minsize .sp 50 50
#
#  Set up the fields in the Photo Table
frame .sp.fields
set ShowTxt "Show Photo"
set NextTxt "Next Photo"
set PrevTxt "Prev Photo"
set ClosTxt "Quit"
button .sp.fields.xv -text $ShowTxt -command XV \
       -width [ string length $ShowTxt] \
       -relief raised
button .sp.fields.next -text $NextTxt -command Next \
       -width [ string length $NextTxt] \
       -relief raised 
button .sp.fields.prev -text $PrevTxt -command Prev \
       -width [ string length $PrevTxt] \
       -relief raised 
button .sp.fields.quit -text $ClosTxt -command {destroy .sp; exit } \
       -width [ string length $ClosTxt] \
       -relief raised 
pack .sp.fields.xv .sp.fields.prev .sp.fields.next .sp.fields.quit \
     -side left -padx 2m -pady 2m -ipadx 2m -ipady 2m
pack .sp.fields 
