#ifndef _TCLMI_H
#define _TCLMI_H
#include "mi.h"
#include <stdio.h>
#include <strings.h>
#include <ctype.h>
#include "tclExtend.h"
#define STREQ(s1, s2)		((*s1) == (*s2) && (strcmp(s1, s2) == 0))
#define STREQN(s1, s2, n)	((*s1) == (*s2) && (strncmp(s1, s2, n) == 0))
#define GROUPED_ROW 0
#define FLAT_ROW 1
#define TM_IDPREFIX		"mid"
#define TM_CIDPREFIX		"mic"

typedef struct {
    Tcl_AsyncHandler asyncHandler;
    MI_EVENT_TYPE event;
    char          *proc;
    char	  eventName[64];
    char	  connId[64];
    Tcl_DString	  *eventData;
} MiEvent;


EXTERN void MiSetId _ANSI_ARGS_((char *id, void *idp));
EXTERN void *MiGetId _ANSI_ARGS_((char *id));
EXTERN int MiGetConn _ANSI_ARGS_((Tcl_Interp *interp, char *cid,
	MI_CONNECTION **conn));
EXTERN int MiGetRdesc _ANSI_ARGS_((Tcl_Interp *interp, char *rdid,
	MI_ROW_DESC **rdesc));
EXTERN int MiGetRow _ANSI_ARGS_((Tcl_Interp *interp, char *rid,
	MI_ROW **row));
EXTERN int MiGetSS _ANSI_ARGS_((Tcl_Interp *interp, char *ssid,
	MI_SAVE_SET **ss));
EXTERN int MiArgv1Conn _ANSI_ARGS_((Tcl_Interp *interp, int argc,
	char **argv, MI_CONNECTION **conn));
EXTERN int MiArgv2ColId _ANSI_ARGS_((Tcl_Interp *interp, int argc,
	char **argv, MI_ROW_DESC **rdesc, int *colid));


#include "MiProtos.h"

#endif				/* _TCLMI_H */
