#
#
# set MD(connection) [ mi_open Prod ]
# mi_exec $MD(connection) "set schema GCMCheat;"
#
#
proc SumN { long lat } {
	global GRID
	if { ($lat<-81) || ($lat>81) || ($long<-174) || ($long>174) } {
		return 0
	}
	set Sum 0
	foreach dy { -4 0 4 } {
		foreach dx { -5 0 5 } {
			set nx [ expr $long + $dx ]
			set ny [ expr $lat + $dy ]
			set Sum [ expr $Sum + $GRID($nx,$ny) ]
		}
	}
	if { $Sum > 0 } {
		return [ expr $Sum - 1 ]
	} else {
		return 0
	}
		
}
#
#
set GC(conn) [ mi_open Prod ]
mi_exec $GC(conn) "set schema GCMTest;"
mi_exec $GC(conn) "begin transaction;"
#
# Get the next Map_Id
#
set Qry "
SELECT MAX(Map_id)
  FROM GCMTest.GCMTest;"
set Mid [ mi_select_first_row $GC(conn) $Qry ]
#
if { $Mid == "MI_ERROR" } {
        puts "ERROR: Failed on $Qry"
        mi_close $GC(conn)
        exit 0
} 
if { $Mid == "(null)" } {
        set Mid 0
}
incr Mid
#
for { set Pass 0 } { $Pass < 3 } { incr Pass } {
	puts " "
	puts " Pass $Pass"
	puts " "
	for { set lat  -86 } { $lat < 86 } { incr lat 4 } {
		for { set long -180 } { $long < 180 } { incr long 5 } {
			if { $Pass == 0 } {
#
# Create the Array
#
				if { [ random 100 ] < 5 } {
					set GRID($long,$lat) [ random 21 ]
					set GRID(alt,$long,$lat) 0
				} else {
					set GRID($long,$lat) 0
					set GRID(alt,$long,$lat) 0
				}
			} else {
				set GRID(alt,$long,$lat) [expr $GRID($long,$lat) + [ SumN $long $lat ] ]
			}
		}
	}
	if { $Pass > 0 } {
		for { set lat  -86 } { $lat < 86 } { incr lat 4 } {
			for { set long -180 } { $long < 180 } { incr long 5 } {
				set GRID($long,$lat)  $GRID(alt,$long,$lat)
			}
		}
	}

}
for { set lat  -86 } { $lat < 86 } { incr lat 4 } {
	set Disp ""
	for { set long -180 } { $long < 180 } { incr long 5 } {
		set longT [ expr $long + 5 ]
		set latT [ expr $lat + 4 ]
		set Box "( $long, $lat,  $longT, $latT )"
		if { $GRID($long,$lat) > 0 } {
			set GRID($long,$lat) [ expr 1 + int(fmod($GRID($long,$lat),3)) ] 
		}
		set Qry "
INSERT INTO GCMTest
( Map_id, BBox, VizUnit, T, U, V, P, Clouds )
VALUES
( $Mid, '$Box'::Box, '$Box'::Path, 0.0, 0.0, 0.0, 0.0, $GRID($long,$lat) );"
		set RetVal [ mi_exec $GC(conn) $Qry ]
		if { $RetVal == "MI_ERROR" } {
			mi_exec $GC(conn) "abort transaction;"
			puts "ERROR: Failed on $Qry"
			exit 0
		}
		set Disp "$Disp $GRID($long,$lat)"
	}
	regsub -all " " $Disp "" Disp
	puts $Disp
}
 mi_exec $GC(conn) "end transaction;"
