/*
 *   remote_dlobh.c
 *
 *    Paul Brown
 *
 *      October 1994, the month from hell!!!11
 *
 *    This file contains the functions which are of great use in
 *   the get_dlobh code. These will be used to make the
 *   get_dlobh executable, which is placed in $MI_HOME/bin
 *   for use in the dlobh 'blade'.
 */
#include "remote_dlobh.h"
#define EIGHT_K 8192

char *
BE_DLOBHToFile ( pDLOBHOut, pcFileName )
dlobh * pDLOBHOut;   
char  * pcFileName;
{
  FILE * fdFileToWriteTo;
  char   szErrorText[1023];
  MI_CONNECTION * pbRemoteConn;
  MI_CONNECTION_INFO pConnectionRemote;
  MI_DATABASE_INFO   pDatabaseRemote;
  char *  szLocalFileToReturn;
  MI_LODESC pbLargeObjectRemote;
  char    szQueryText[512];
  int     nWhence,
	  nBytesToWrite;
  char *  pRetVal;

  dlobhGetConnectionInfo(pDLOBHOut, &pConnectionRemote);

  if ((pbRemoteConn=mi_server_connect(&pConnectionRemote))!=NULL)
  {
     dlobhGetDatabaseInfo( pDLOBHOut, &pDatabaseRemote);

     if (mi_login(pbRemoteConn,&pDatabaseRemote) != MI_ERROR)
     {
        switch(pDLOBHOut->ObjectType)
        {
	  case 'I':
             sprintf(szQueryText,"return LOToFile('%s','%s');",
                     pDLOBHOut->LOBHData,
                     pcFileName);
            break;
	  default:
/*
 * If this is a localfile, then just return the name of the file. This 
 * prevents us from bringing files out which are already resident.
 */
             sprintf(szQueryText,
                     "select LOToFile(E.Ext_LO_Name,'%s') from DLOBH.Externals E where E.File_Name = '%s';",
                     pcFileName,
                     pDLOBHOut->LOBHData);
           break;
        }

        if (mi_exec(pbRemoteConn,szQueryText)!=MI_ERROR)
        {
           if ((pRetVal = get_result(pbRemoteConn)) != (char *) NULL)
	   {
              if (mi_query_finish(pbRemoteConn)!=MI_ERROR)
	      {
		 mi_close(pbRemoteConn);

	         return (pRetVal);

              } else 
              sprintf(szErrorText,"DLOBHToFile: Didn't finish the query.");

           } else 
           sprintf(szErrorText,"DLOBHToFile: Couldn't get any result.");

        } else 
        sprintf(szErrorText,"DLOBHToFile: mi_exec failed on the function %s",
                            szQueryText);

     } else 
     sprintf(szErrorText,
     "DLOBHToFile: Failed login to %s database as %s Password OK?",
     pDLOBHOut->DBaseName,
     pDLOBHOut->DBaseUserName);
  } else 
  {
     sprintf(szErrorText,
        "DLOBHToFile: Cannot open Connection to server with (%s:%d/%s)",
        pDLOBHOut->ServerHost,
	pDLOBHOut->ServerPort,
	pDLOBHOut->ServerName);
  }
     return szErrorText;
}
